//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2010)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org

#include <iostream>
#include <string>
#include <wx/wx.h>

using namespace std;

class projectFileAnalsis
{
    public:
        void analyzeProjectFileContent(string fileContent);
        void analyzeVBoreFileContent(string fileVBore);
        long getNumberSurferGRIDS(){return numSurferGRIDS;};
        wxString getStrSurferGRIDS(long i){return surferGRIDS[i];};
        wxString getStrVertScale3D(){return vertScale3D;};
        wxString getStrHorScale3D(){return horScale3D;};
        wxString getStrVertScale2D(){return vertScale2D;};
        wxString getStrHorScale2D(){return horScale2D;};
        wxString getStrVertScale1D(){return vertScale1D;};
        wxString getStrHorAngle3D(){return horAngle3D;};
        wxString getStrVertAngle3D(){return vertAngle3D;};
        wxString getStrOffset3D(){return offset3D;};
        wxString getStrCSLine(){return fileStringCrossSectionLine;};
        wxString getStrXCoordinate1D(){return xCoordinate1D;};
        wxString getStrYCoordinate1D(){return yCoordinate1D;};
        wxString getStrXCoordVBore(){return xCoordVBore;};
        wxString getStrYCoordVBore(){return yCoordVBore;};
        
        
    private:
        long numSurferGRIDS;
        wxString *surferGRIDS;
        wxString vertScale3D;
        wxString horScale3D;
        wxString vertScale2D;
        wxString horScale2D;
        wxString vertScale1D;
        wxString horAngle3D;
        wxString vertAngle3D;
        wxString offset3D;
        wxString fileStringCrossSectionLine;
        wxString xCoordinate1D;
        wxString yCoordinate1D;
        wxString xCoordVBore;
        wxString yCoordVBore;
};

