//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2011)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org


#ifndef __VIEWER_GUI1FRM_H__
#define __VIEWER_GUI1FRM_H__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/frame.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/menu.h>
#include <wx/filedlg.h>
#include <wx/listbox.h>
#include <wx/bmpbuttn.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/button.h>
#include <wx/panel.h>
#include <wx/notebook.h>
////Header Include End
#include <iostream>
#include <fstream>
////Dialog Style Start
#undef viewer_gui1Frm_STYLE
#define viewer_gui1Frm_STYLE wxCAPTION | wxSYSTEM_MENU | wxMINIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End

using namespace std;

class viewer_gui1Frm : public wxFrame
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		viewer_gui1Frm(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("viewer_gui1"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = viewer_gui1Frm_STYLE);
		virtual ~viewer_gui1Frm();
		void WxButton1Click(wxCommandEvent& event);
		void Mnuexit1004Click(wxCommandEvent& event);
		void Mnuopenproject1002Click(wxCommandEvent& event);
		void Mnuaddsurfergr1006Click(wxCommandEvent& event);
		void WxListBoxLayerNamesSelected(wxCommandEvent& event);
		void Mnuaddesrigr1007Click(wxCommandEvent& event);
		void Mnuaddxyzdata1009Click(wxCommandEvent& event);
		void Mnudeletefromproject1010Click(wxCommandEvent& event);
		void WxButtonVBoreCreateShowClick(wxCommandEvent& event);
		void WxButtonCreateCSClick(wxCommandEvent& event);
		void Mnusaveproject1003Click(wxCommandEvent& event);
		void WxEdit1ClickUrl(wxTextUrlEvent& event);
		void WxBitmapButtonCSLineFileLoadClick(wxCommandEvent& event);
		void WxBitmapButton1Click(wxCommandEvent& event);
		
	private:
		//Do not add custom control declarations between
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxFileDialog *WxOpenFileDialogSurferGRID;
		wxMenuBar *WxMenuBar1;
		wxFileDialog *WxOpenFileDialogCSLine;
		wxFileDialog *WxOpenProjFileDialog;
		wxFileDialog *WxSaveFileDialogProjectFile;
		wxFileDialog *WxOpenFileDialogVBorehole;
		wxListBox *WxListBoxLayerNames;
		wxBitmapButton *WxBitmapButton1;
		wxButton *WxButtonVBoreCreateShow;
		wxTextCtrl *WxEditVBoreholeGetDataFromFile;
		wxStaticText *WxStaticTextVBoreholeGetCoordFRomFile;
		wxTextCtrl *WxEditVBoreholeVertScale;
		wxStaticText *WxStaticTextVBoreholeVertScale;
		wxStaticText *WxStaticTextVBoreYCoord;
		wxStaticText *WxStaticText6;
		wxTextCtrl *WxEditVBoreYCoord;
		wxTextCtrl *WxEditVBoreXCoord;
		wxPanel *WxNoteBookPage3;
		wxBitmapButton *WxBitmapButtonCSLineFileLoad;
		wxButton *WxButtonCreateCS;
		wxTextCtrl *WxEditVertScaleCS;
		wxTextCtrl *WxEdit2;
		wxTextCtrl *WxEdit1;
		wxStaticText *WxStaticText9;
		wxStaticText *WxStaticText8;
		wxStaticText *WxStaticText7;
		wxPanel *WxNoteBookPage2;
		wxStaticText *WxStaticText5;
		wxStaticText *WxStaticText4;
		wxStaticText *WxStaticText3;
		wxStaticText *WxStaticText2;
		wxStaticText *WxStaticText1;
		wxTextCtrl *WxEditOffsetSl;
		wxTextCtrl *WxEditVertScale;
		wxTextCtrl *WxEditHorScale;
		wxTextCtrl *WxEditVertAngle;
		wxTextCtrl *WxEditHorizAngle;
		wxButton *WxButtonCS3D;
		wxPanel *WxNoteBookPage1;
		wxNotebook *WxNotebook1;
		////GUI Control Declaration End
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_MNU_FILE_1001 = 1001,
			ID_MNU_OPENPROJECT_1002 = 1002,
			ID_MNU_SAVEPROJECT_1003 = 1003,
			ID_MNU_EXIT_1004 = 1004,
			ID_MNU_SURFACES_1005 = 1005,
			ID_MNU_ADDSURFERGRID_1006 = 1006,
			ID_MNU_ADDESRIGRID_1007 = 1007,
			ID_MNU_ADDXYZDATA_1009 = 1009,
			ID_MNU_DELETEFROMPROJECT_1010 = 1010,
			ID_MNU_HELP_1008 = 1008,
			
			ID_WXLISTBOXLAYERNAMES = 1030,
			ID_WXBITMAPBUTTON1 = 1054,
			ID_WXBUTTONVBORECREATESHOW = 1051,
			ID_WXEDITVBOREHOLEGETDATAFROMFILE = 1050,
			ID_WXSTATICTEXTVBOREHOLEGETCOORDFROMFILE = 1049,
			ID_WXEDITVBOREHOLEVERTSCALE = 1048,
			ID_WXSTATICTEXTVBOREHOLEVERTSCALE = 1047,
			ID_WXSTATICTEXTVBOREYCOORD = 1046,
			ID_WXSTATICTEXT6 = 1045,
			ID_WXEDITVBOREYCOORD = 1044,
			ID_WXEDITVBOREXCOORD = 1043,
			ID_WXNOTEBOOKPAGE3 = 4,
			ID_WXBITMAPBUTTONCSLINEFILELOAD = 1052,
			ID_WXBUTTONCREATECS = 1028,
			ID_WXEDITVERTSCALECS = 1027,
			ID_WXEDIT2 = 1026,
			ID_WXEDIT1 = 1025,
			ID_WXSTATICTEXT9 = 1024,
			ID_WXSTATICTEXT8 = 1023,
			ID_WXSTATICTEXT7 = 1022,
			ID_WXNOTEBOOKPAGE2 = 3,
			ID_WXSTATICTEXT5 = 1042,
			ID_WXSTATICTEXT4 = 1041,
			ID_WXSTATICTEXT3 = 1040,
			ID_WXSTATICTEXT2 = 1039,
			ID_WXSTATICTEXT1 = 1038,
			ID_WXEDITOFFSETSL = 1037,
			ID_WXEDITVERTSCALE = 1036,
			ID_WXEDITHORSCALE = 1035,
			ID_WXEDITVERTANGLE = 1034,
			ID_WXEDITHORIZANGLE = 1033,
			ID_WXBUTTONCS3D = 1032,
			ID_WXNOTEBOOKPAGE1 = 1031,
			ID_WXNOTEBOOK1 = 1,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
		
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
};

#endif
