//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2010)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org


#include <iostream>
#include <fstream>
#include <string>
#include "create_faces.h"

using namespace std;

void genFaces::calcNumFacesFromGRID(long numCols, long numRows)
{
    num_faces = ((numCols-1)*2)*(numRows-1);
    ncols=numCols;
    nrows=numRows;
}
void genFaces::vertexFacesID(long vID1[], long vID2[], long vID3[])
{
    long counterFaces=0, counterCols=0, counterRows=0, n_points_per_slice=0;
    
    n_points_per_slice=ncols*nrows;

    for(counterRows=0;counterRows<nrows-1;counterRows++)
    {
         for(counterCols=0;counterCols<ncols-1;counterCols++)
         {        
                //vertices of top side        
                vID1[counterFaces]=counterCols+counterRows*ncols;
                vID3[counterFaces]=counterCols+1+(counterRows+1)*ncols;
                vID2[counterFaces]=counterCols+(counterRows+1)*ncols;
                //vertices of bottom side
                vID1[counterFaces+num_faces]=(counterCols+counterRows*ncols)+n_points_per_slice;
                vID3[counterFaces+num_faces]=(counterCols+1+(counterRows+1)*ncols)+n_points_per_slice;
                vID2[counterFaces+num_faces]=(counterCols+(counterRows+1)*ncols)+n_points_per_slice;
                counterFaces++;          
                //vertices of top side  
                vID1[counterFaces]=counterCols+counterRows*ncols;
                vID3[counterFaces]=counterCols+1+counterRows*ncols;
                vID2[counterFaces]=counterCols+1+(counterRows+1)*ncols;
                //vertices of bottom side
                vID1[counterFaces+num_faces]=(counterCols+counterRows*ncols)+n_points_per_slice;
                vID3[counterFaces+num_faces]=(counterCols+1+counterRows*ncols)+n_points_per_slice;
                vID2[counterFaces+num_faces]=(counterCols+1+(counterRows+1)*ncols)+n_points_per_slice;
                counterFaces++;
         }  
    }
    counterFaces=2*num_faces;
    for(counterCols=0;counterCols<ncols-1;counterCols++)
    {
        //vertices southern side
        vID1[counterFaces]=counterCols;
        vID2[counterFaces]=counterCols+n_points_per_slice+1;
        vID3[counterFaces]=counterCols+n_points_per_slice;
        counterFaces++;
        //vertices southern side
        vID1[counterFaces]=counterCols;
        vID2[counterFaces]=counterCols+1;
        vID3[counterFaces]=counterCols+1+n_points_per_slice;
        counterFaces++;
        
        //vertices northern side
        vID1[counterFaces]=counterCols+n_points_per_slice-ncols;
        vID3[counterFaces]=counterCols+2*n_points_per_slice-ncols+1;
        vID2[counterFaces]=counterCols+2*n_points_per_slice-ncols;
        counterFaces++;
        //vertices northern side
        vID1[counterFaces]=counterCols+n_points_per_slice-ncols;
        vID3[counterFaces]=counterCols+n_points_per_slice-ncols+1;
        vID2[counterFaces]=counterCols+2*n_points_per_slice-ncols+1;
        counterFaces++;
    }

    counterFaces=2*num_faces+4*ncols;
    for(counterRows=0;counterRows<nrows-1;counterRows++)
    {
        //vertices western side
        vID1[counterFaces]=counterRows*ncols;
        vID3[counterFaces]=(counterRows+1)*ncols+n_points_per_slice;
        vID2[counterFaces]=counterRows*ncols+n_points_per_slice;
        counterFaces++;
        //vertices western side
        vID1[counterFaces]=counterRows*ncols;
        vID3[counterFaces]=(counterRows+1)*ncols;
        vID2[counterFaces]=(counterRows+1)*ncols+n_points_per_slice;
        counterFaces++;
        
        //vertices eastern side
        vID1[counterFaces]=counterRows*ncols+(ncols-1);
        vID2[counterFaces]=(counterRows+1)*ncols+n_points_per_slice+(ncols-1);
        vID3[counterFaces]=counterRows*ncols+n_points_per_slice+(ncols-1);
        counterFaces++;
        //vertices eastern side
        vID1[counterFaces]=counterRows*ncols+(ncols-1);
        vID2[counterFaces]=(counterRows+1)*ncols+(ncols-1);
        vID3[counterFaces]=(counterRows+1)*ncols+n_points_per_slice+(ncols-1);
        counterFaces++;
    }

}
